local RaidHelper = {
	Debug = false
}
local RaidCounter = {
	[527] = 3,
	[528] = 3,
	[529] = 3,
	[530] = 3,
	[526] = 4,
	[610] = 3,
	[611] = 3,
	[612] = 3,
	[613] = 3,
	[716] = 4,
	[717] = 4,
	[724] = 3,
	[725] = 3,
	[726] = 4,
	[728] = 4,
	[729] = 3,
	[730] = 3,
	[849] = 3,
	[850] = 3,
	[851] = 1,
	[847] = 3,
	[846] = 3,
	[848] = 3,
	[823] = 1,
}

local function isRaidFinderDungeonDisplayable(id)
	local name, typeID, subtypeID, minLevel, maxLevel, _, _, _, expansionLevel = GetLFGDungeonInfo(id)
	local myLevel = UnitLevel("player")
	return myLevel >= minLevel and myLevel <= maxLevel and EXPANSION_LEVEL >= expansionLevel
end

function RaidFinderQueueFrameSelectionDropDown_Initialize(self)
	local info = UIDropDownMenu_CreateInfo()
	for i=1, GetNumRFDungeons() do
		local id, name = GetRFDungeonInfo(i)
		local isAvailable, isAvailableToPlayer, hideIfUnmet = IsLFGDungeonJoinable(id)
		local totalEncounters, BossKill = GetLFGDungeonNumEncounters(id)
		if BossKill == RaidCounter[id] then
			name = string.format("|cffff0000%s [%d/%d]|r", name , BossKill, RaidCounter[id])
		else
			name = string.format("%s [%d/%d]", name , BossKill, RaidCounter[id])
		end
		if RaidHelper.Debug then
			name = string.format("%s [%d/%d - Boss: %d] [ID: %d]", name , BossKill, RaidCounter[id], totalEncounters, id)
		end
		if( not hideIfUnmet or isAvailable ) then
			if ( isAvailable or isAvailableToPlayer or isRaidFinderDungeonDisplayable(id) ) then
				if ( isAvailable ) then
					info.text = name
					info.value = id
					info.isTitle = nil
					info.func = RaidFinderQueueFrameSelectionDropDownButton_OnClick
					info.disabled = nil
					info.checked = (RaidFinderQueueFrame.raid == info.value)
					info.tooltipWhileDisabled = nil
					info.tooltipOnButton = nil
					info.tooltipTitle = nil
					info.tooltipText = nil
					UIDropDownMenu_AddButton(info)
				else
					info.text = name
					info.value = id
					info.isTitle = nil
					info.func = nil
					info.disabled = 1
					info.checked = nil
					info.tooltipWhileDisabled = 1
					info.tooltipOnButton = 1
					info.tooltipTitle = YOU_MAY_NOT_QUEUE_FOR_THIS
					info.tooltipText = LFGConstructDeclinedMessage(id)
					UIDropDownMenu_AddButton(info)
				end
			end
		end
	end
end

